// Macros for "EXIT" window


#define x_window 29.05 	// Height of the main start-up window. 

#define y_window 14.97	// Width of the main start-up window.

#define x_window_exit 30.0	// Position determinants of "EXIT" window  

#define y_window_exit 15.0	// Position determinants of "EXIT" window

#define x_image_exit 1.9	// Position determinants of image in "EXIT" window

#define y_image_exit 0.7	// Position determinants of image in "EXIT" window

#define x_YES_left 1.6		// Position determinants of "YES" button in "EXIT" window

#define x_YES_right 4.6		// Position determinants of "YES" button in "EXIT" window

#define y_YES_up 2.5		// Position determinants of "YES" button in "EXIT" window

#define y_YES_down 3.3		// Position determinants of "YES" button in "EXIT" window

#define x_NO_left 8.4		// Position determinants of "NO" button in "EXIT" window

#define x_NO_right 11.4		// Position determinants of "NO" button in "EXIT" window

#define y_NO_up 2.4			// Position determinants of "NO" button in "EXIT" window

#define y_NO_down 3.2		// Position determinants of "NO" button in "EXIT" window

#define x_text_left 4.9 	// Positon parameters for text in "EXIT" window

#define x_text_right 9.1	// Positon parameters for text in "EXIT" window

#define y_text_up 0.9		// Positon parameters for text in "EXIT" window

#define y_text_down 1.7		// Positon parameters for text in "EXIT" window

#define length 13.0			// Width of "EXIT" window

#define height 4.0			// Height of "EXIT" window

SimpleWindow w_exit("QUIT GAME?",length,height,Position(x_window_exit/2-length/2,y_window_exit/2-height/2));
												// "EXIT" window
BitMap w_exc(w_exit);	// Bitmap in "EXIT" window

SimpleWindow w("POCKET TANKS",x_window,y_window);	// Main page window 

BitMap w_bmp(w);			// Bitmap image for main page
		

int CLICK(const Position &p)	// This function is called when mouse is clicked in the "exit" window
{
	// Checking if "YES" button is clicked
	
	if(p.GetXDistance()>=x_YES_left && p.GetXDistance()<=x_YES_right && p.GetYDistance()	
 	>=y_YES_up && p.GetYDistance()<=y_YES_down)
    {
		w_exit.Close();		// If "YES" is clicked close "EXIT" window
		w.Close();			// And close the main window
		return 1;
    }

	// Checking if "NO" button is clicked	
	
 	else if(p.GetXDistance()>=x_NO_left && p.GetXDistance()<=x_NO_right && p.GetYDistance()
    >=y_NO_up && p.GetYDistance()<=y_NO_down)					
 	{						
     	w_exit.Close();		// If "NO" is clicked close "EXIT" window
     	ApiMain();			// And open the main window 
		return 1;		
    }
	else return 0;
}

void exit_game()		
{		   

 	w_exit.Open();											// Opening a pop-up window on the main game window
    assert(w_exit.GetStatus() == WindowOpen);				// Asserting if the window has opened


    Position Center = w_exit.GetCenter();					// Getting co-ordinates of the center
    Position Image  = Position(x_image_exit,y_image_exit);	// Position of the image 


	// Creating background
    RectangleShape BackGround(w_exit,Position(0.0,0.0),Black,160,100);	
    BackGround.Draw();


    w_exc.Load("exclamation.xpm");		// Bitmap image to be displayed along with the text
    w_exc.SetPosition(Image);
    w_exc.Draw();						// Drawing the bitmap at position required


    Position UpperLeft_text = Position(x_text_left,y_text_up);		// Parameters for text position
	Position LowerRight_text = Position(x_text_right,y_text_down);


    w_exit.RenderText(UpperLeft_text,LowerRight_text,"DO YOU REALLY WANT TO QUIT?",White,Black);


    Position UpperLeft_YES = Position(x_YES_left,y_YES_up);			// For option "YES"
	Position LowerRight_YES = Position(x_YES_right,y_YES_down);

    w_exit.RenderRectangle(UpperLeft_YES,LowerRight_YES,White,false);

    w_exit.RenderText(UpperLeft_YES,LowerRight_YES,"YES",Black);	// Generating the "YES" button


    Position UpperLeft_NO = Position(x_NO_left,y_NO_up);			// For option "NO"
	Position LowerRight_NO = Position(x_NO_right,y_NO_down);

    w_exit.RenderRectangle(UpperLeft_NO,LowerRight_NO,White,false);

    w_exit.RenderText(UpperLeft_NO,LowerRight_NO,"NO",Black);		// Generating the "NO" button


    w_exit.SetMouseClickCallback(CLICK);							// Mouse click interface to return to the main menu 

}


