
// Macros of "INSTRUCTIONS" window

#define WIDTH 30.0		// Width of "INSTRUCTIONS" window 

#define HEIGHT 15.0		// Height of "INSTRUCTIONS" window

#define X_START 2.0		// Parameters for placing image and text as required

#define Y_START 5.0		// Parameters for placing image and text as required

#define X_END 22.0		// Parameters for placing image and text as required

#define BackButtonTop 13.5		// Back button position deteminants

#define BackButtonBottom 14.5	// Back button position deteminants

#define BackButtonLeft 2.0		// Back button position deteminants

#define BackButtonRight 5.0		// Back button position deteminants							



SimpleWindow w_instructions("INSTRUCTIONS - POCKET TANKS",WIDTH,HEIGHT);	// "INSTRUCTIONS" window

BitMap w_instructions_bmp(w_instructions);	//Bitmap image in this window



int OnMouseClick(const Position &p)	// This function is called when mouse is clicked on the "INSTRUCTIONS" window
{
	//Checking if the back button in the "INSTRUCTIONS" window is clicked
	
	if((p.GetXDistance()<=BackButtonRight)&&(p.GetXDistance()>=BackButtonLeft))
    {											 
      											 
		 if((p.GetYDistance()>=BackButtonTop)&&(p.GetYDistance()<=BackButtonBottom))		
        {
			w_instructions.Close();		// If yes close "INSTRUCTIONS" window
			ApiMain();					// And open the main window
        }
    }
	return 1;

}


void instructions()
{
		   
	w_instructions.Open();								// Opening the instructions window already declared
	assert(w_instructions.GetStatus() == WindowOpen);	// Asserting if the window has opened
	Position Center=w_instructions.GetCenter();			// Get position of center for reference


	// Creating a black background
	RectangleShape BackGround(w_instructions,Position(0.0,0.0),Black,WIDTH*10,HEIGHT*10);
	BackGround.Draw();					


	Position I=Position((X_START+X_END)/2,Y_START/4);		// Selecting position of bitmap image
	w_instructions_bmp.Load("image.xpm");			 		// And loading it
	assert(w_instructions_bmp.GetStatus() == BitMapOkay);	// Asserting if image has loaded
	w_instructions_bmp.SetPosition(I);		
	w_instructions_bmp.Draw();								// Draw the bitmap image


	Position UpperLeft1=Position(X_START,Y_START);			// Defining the left top and right bottom positions to
															// create bounding box for text
	Position LowerRight1=Position(X_END,Y_START+1);
	w_instructions.RenderText(UpperLeft1,LowerRight1,"GENERAL INSTRUCTIONS:",Green,Black);	
	// Defining colour of text and box colour


	Position UpperLeft2=Position(X_START,Y_START+1.5);		// Similar definitions for the remaining text
	Position LowerRight2=Position(X_END,Y_START+2);			// But varying the box positions as per need
	w_instructions.RenderText(UpperLeft2,LowerRight2,"POCKET TANKS is a simple artillery game with two tanks in a terrain ready to fire at each other",Blue,Black);


	Position UpperLeft3=Position(X_START,Y_START+2);
	Position LowerRight3=Position(X_END,Y_START+2.5);
	w_instructions.RenderText(UpperLeft3,LowerRight3,"The player can choose to play either a single player game or a multiplayer game.",Blue,Black);

	
	Position UpperLeft4=Position(X_START,Y_START+2.5);
	Position LowerRight4=Position(X_END,Y_START+3);
	w_instructions.RenderText(UpperLeft4,LowerRight4,"Each player begins with the same points which decrease when his/her tank gets hit.",Blue,Black);


	Position UpperLeft5=Position(X_START,Y_START+3);
	Position LowerRight5=Position(X_END,Y_START+3.5);
	w_instructions.RenderText(UpperLeft5,LowerRight5,"The game ends when a player's points tally goes to zero and the other player wins.",Blue,Black);


	Position UpperLeft6=Position(X_START,Y_START+4);
	Position LowerRight6=Position(X_END,Y_START+4.5);
	w_instructions.RenderText(UpperLeft6,LowerRight6,"PLAYING THE GAME:",Green,Black);	// Sub-Heading


	Position UpperLeft7=Position(X_START,Y_START+5);
	Position LowerRight7=Position(X_END,Y_START+5.5);
	w_instructions.RenderText(UpperLeft7,LowerRight7,"Select power and angle with which the bullet has to be fired.",Blue,Black);

 	
	Position UpperLeft8=Position(X_START,Y_START+5.5);
	Position LowerRight8=Position(X_END,Y_START+6);
	w_instructions.RenderText(UpperLeft8,LowerRight8,"You can move the tank 4 times either to the left or to the right.",Blue,Black);

	
	Position UpperLeft9=Position(X_START,Y_START+6);
	Position LowerRight9=Position(X_END,Y_START+6.5);
	w_instructions.RenderText(UpperLeft9,LowerRight9,"Strategy is key to winning.",Blue,Black);


	Position UpperLeft10=Position(X_START,Y_START+6.5);
	Position LowerRight10=Position(X_END,Y_START+7);
	w_instructions.RenderText(UpperLeft10,LowerRight10,"It's one thing to hit your opponent on a turn-by-turn basis,but it pays to think ahead.",Blue,Black);

	
	Position UpperLeft11=Position(X_START,Y_START+7.5);
	Position LowerRight11=Position(X_END,Y_START+8);
	w_instructions.RenderText(UpperLeft11,LowerRight11,"HAVE FUN!!",Magenta,Black);
	

	// The "BACK" button	

	w_instructions.RenderRectangle(Position(BackButtonLeft,BackButtonTop),Position(BackButtonRight,BackButtonBottom),Green,true);	
	w_instructions.RenderText(Position(BackButtonLeft,BackButtonTop),Position(BackButtonRight,BackButtonBottom)," BACK",Red,Green);
	// Defining a bounding box for the back button
	
	
	w_instructions.SetMouseClickCallback(OnMouseClick);	
	// OnMouseClick function is called when mouse is clicked on the window
}

