/*
This is the complete program for the main start-up page.
This program opens a page with title "POCKET TANKS".

The page has 5 buttons:
SINGLE PLAYER
MULTI-PLAYER
INSTRUCTIONS
ABOUT THE GAME
EXIT

On clicking "SINGLE PLAYER" and "MULTI-PLAYER", the terminal asks the name of the user and 
after entering the name, the game screen opens.
On clicking "INSTRUCTIONS", another page opens giving instructions to the user.
On clicking "ABOUT THE GAME", another page opens which contains details like credits,copyrights, etc.
On clicking "EXIT", a pop-up window opens which asks whether the user really wants to quit or not.
*/ 

#include <iostream>

#include "ezwin.h"

#include "bitmap.h"

#include "rect.h"

#include <cassert>

#include "exit_dialog.cpp"

#include "about_the_game.cpp"

#include "instructions.cpp"


// Macros for main start-up window


#define x_image 10.0	// x-position of image can be adjusted by changing values here

#define y_image 0.2		// y-position of image

#define x_single_player_left 13.0	// Position of button "SINGLE PLAYER" 

#define x_single_player_right 17.0	// Position of button "SINGLE PLAYER"

#define y_single_player_up 5.0		// Position of button "SINGLE PLAYER"

#define y_single_player_down 6.0	// Position of button "SINGLE PLAYER"


using namespace std;
// Defining all windows being used along with their names and dimensions
// Also defining the bitmap images 



void single_player()
{
	/* CODE FOR SINGLE PLAYER TO BE ENTERED HERE.
	
	CODE FOR SINGLE PLAYER TO BE ENTERED HERE.*/		   
	cout<<"Single Player !!"<<endl;
}


void multi_player()
{
	/* CODE FOR MULTI PLAYER TO BE ENTERED HERE.

	CODE FOR MULTI PLAYER TO BE ENTERED HERE.*/		   
	cout<<"Multi-Player !!"<<endl;

}

int position_of_click(const Position &p)
{
	// Loop goes on till some button is clicked and value is returned
	while (1)
	{
		
		// Checking if "SINGLE PLAYER" button has is clicked
		if (p.GetXDistance()>=x_single_player_left && p.GetXDistance()<=x_single_player_right && p.GetYDistance()
 		>=y_single_player_up && p.GetYDistance()<=y_single_player_down)		
										
		{
			single_player();	// If yes single_player function is invoked
			return 1;
		}

		
		//Checking if "MULTI-PLAYER" button is clicked
		else if (p.GetXDistance()>=x_single_player_left && p.GetXDistance()<=x_single_player_right && p.GetYDistance()
 		>=y_single_player_up + 2 && p.GetYDistance()<=y_single_player_down + 2)		 

		{
			multi_player();		// If yes multi_player function is invoked
			return 2;
		}


		// Checking if "INSTRUCTIONS" button is clicked
		else if (p.GetXDistance()>=x_single_player_left && p.GetXDistance()<=x_single_player_right && p.GetYDistance()
 		>=y_single_player_up + 4 && p.GetYDistance()<=y_single_player_down + 4)		 

		{
			instructions();		// If yes instructions function is invoked
			return 3;
		}
		
		
		// Checking if "ABOUT THE GAME" button is clicked
		else if (p.GetXDistance()>=x_single_player_left && p.GetXDistance()<=x_single_player_right && p.GetYDistance()
 		>=y_single_player_up + 6 && p.GetYDistance()<=y_single_player_down + 6)		

		{	
			about_the_game();	// If yes about_the_game function is invoked
			return 4;			
		}


		// Checking if "EXIT" button is clicked
		else if (p.GetXDistance()>=x_single_player_left && p.GetXDistance()<=x_single_player_right && p.GetYDistance()
 		>=y_single_player_up + 8 && p.GetYDistance()<=y_single_player_down + 8)		

		{
			exit_game();		// If yes exit_game function is invoked
			return 0;
		}
	}
}

   
int ApiMain() 
{

  	w.Open();										// Opening the main window
	assert(w.GetStatus() == WindowOpen);			// Asserting if main window opened

	Position Center = w.GetCenter();				// Getting positon of center of page

	Position Image = Position(x_image,y_image);		//Position of image


	//Creating background
	RectangleShape BackGround(w,Position(0.0,0.0),Black,x_window*10,y_window*10);
	BackGround.Draw();		

	
	w_bmp.Load("image.xpm");					// Loading image
	assert(w_bmp.GetStatus() == BitMapOkay);	// Asserting if image is loaded
	w_bmp.SetPosition(Image);
	w_bmp.Draw();								//Drawing the bitmap image


	// Defining a bounding box for the text "SINGLE PLAYER"
	Position UpperLeft_SinglePlayer = Position(x_single_player_left,y_single_player_up);
	Position LowerRight_SinglePlayer = Position(x_single_player_right,y_single_player_down);

	w.RenderRectangle(UpperLeft_SinglePlayer,LowerRight_SinglePlayer,Green, true);		

	w.RenderText(UpperLeft_SinglePlayer,LowerRight_SinglePlayer,"SINGLE PLAYER",Red,Green);
	

	// Defining a bounding box for the text "MULTI-PLAYER"
	Position UpperLeft_MultiPlayer = Position(x_single_player_left,y_single_player_up + 2);
	Position LowerRight_MultiPlayer = Position(x_single_player_right,y_single_player_down + 2);

	w.RenderRectangle(UpperLeft_MultiPlayer,LowerRight_MultiPlayer,Green, true);	
												
	w.RenderText(UpperLeft_MultiPlayer,LowerRight_MultiPlayer,"MULTI-PLAYER",Red,Green);	


	// "INSTRUCTIONS" button
	Position UpperLeft_Instructions = Position(x_single_player_left,y_single_player_up + 4);
	Position LowerRight_Instructions = Position(x_single_player_right,y_single_player_down + 4);

	w.RenderRectangle(UpperLeft_Instructions,LowerRight_Instructions,Green, true);		

	w.RenderText(UpperLeft_Instructions,LowerRight_Instructions,"INSTRUCTIONS",Red,Green);


	// "ABOUT THE GAME" button
	Position UpperLeft_About_Game = Position(x_single_player_left,y_single_player_up + 6);
	Position LowerRight_About_Game = Position(x_single_player_right,y_single_player_down + 6);

	w.RenderRectangle(UpperLeft_About_Game,LowerRight_About_Game,Green, true);	

	w.RenderText(UpperLeft_About_Game,LowerRight_About_Game,"ABOUT THE GAME",Red,Green);


	// "EXIT" button
	Position UpperLeft_Exit = Position(x_single_player_left,y_single_player_up + 8);
	Position LowerRight_Exit = Position(x_single_player_right,y_single_player_down + 8);

	w.RenderRectangle(UpperLeft_Exit,LowerRight_Exit,Green, true);	

	w.RenderText(UpperLeft_Exit,LowerRight_Exit,"EXIT",Red,Green);	


	w.SetMouseClickCallback(position_of_click);		// Calling positon_of_click when mouse is clicked

  
  	return 0;
}

// End of the ApiMain() function

int ApiEnd()
{

	w.Close();		// Close main page window
	return 0;
}
