/*

The following program accepts the horizontal and verical velocities of a projectile and periodically displays the coordinates of the projectile
until it is back again to the point of projection.

By Nivvedan S

Started Typing - 02:43 16 October 2010
Completely Done - 03:47 16 October 2010


The following piece of code if released under GNU GPL licence. You are 
free to redistribute/modify it under the terms of the GNU Lesser General
Public License either version 2.1 of the License, or (at your option) any later version.

The following code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

Assumptions done here are:-

1. The actual function projectile() is called by the GUI and therefore exception handling inside the function is rendered unneccsary as it would be done in the GUI itself
2. The inputs x_vel and y_vel are from another function and therefore is already scaled such that the bullet doesn't go out of screen bounds

Bug Hunting and Further improvements are welcome.
Just drop a mail to nivvedan@iitb.ac.in

*/

# include <iostream>
# include <ctime>


# define WAITTIME 39           // Arbitary time (in milliseconds) to wait before every successive coordinate in the projectile's trajectory is returned
# define GROUND 80             // Ground's coordinates
# define g 9.8								// The infamous acceleration due to gravity

using namespace std;

clock_t t_initial;

int projectile(double *x_coor, double *y_coor, double *x_vel, double *y_vel);   // Prototype for our lead funtion

int main()
{

    double x_vel, y_vel, x_coor=0, y_coor=GROUND;

    cout<<"Please enter the horizontal component of the projectile's velocity : ";
    cin>>x_vel;
    cout<<"Please enter the verital component of the projectile's velocity : ";
    cin>>y_vel;
    cout<<endl;

    /*
        -----------------------DEBUGGING CODE-----------------------------------------
				---------------Uncomment the following lines for debugging--------------------
            double actualtime=2*y_vel/g;
    */
    clock_t total=clock();
    t_initial=clock();
    int i=0;
    while(GROUND>=y_coor)
    {
        projectile(&x_coor,&y_coor,&x_vel,&y_vel);
        /*
            -----------------------DEBUGGING CODE-------------------------------------
						----------------Uncomment the following lines for debugging---------------
                
						cout<<i++;
        */
        cout<<x_coor<<"\t"<<y_coor<<endl;
    }
    /*
        -----------------------DEBUGGING CODE------------------------------------------
				---------------Uncomment the following lines for debugging---------------------
            
						cout<<double(t_initial-total)/CLOCKS_PER_SEC;
            cout<<endl<<"Actual time taken is "<<actualtime<<endl;
    */
    return 0;
}

int projectile (double *x_coor, double *y_coor, double *x_vel, double *y_vel)
{

    clock_t t_curr=clock();		// Current time
    double time = (double(t_curr-t_initial))/CLOCKS_PER_SEC;	// Calculates how much time was elased since the last time the projectile's parameters were computed

		/*

		The main part of the entire code.
		calculating the velocities and the coordinates

		*/

    *x_coor=*x_coor+*x_vel*time;		
    *y_coor=*y_coor-(*y_vel*time)+(0.5*g*time*time);
    *y_vel=*y_vel-g*time;

    t_initial=clock();			// Time as soon as the most recent computation is over. To be used during the next function call.

	/*

	The following part is just for time delay. It waits for a little over 39 milliseconds
	before proceeding to exit the funtion

	*/

    clock_t t_wait=clock();
    while(WAITTIME>(double(t_wait-t_curr)*1000/CLOCKS_PER_SEC))
    {
        t_wait=clock();
    }

    return 0;

}

// That's it....REALLY